{

    // Anbi火刀附魔(次数限定版)

    "AbilityName": "Anbi_Fire_Enhance",

    "AbilityStacking": "Unique",

    "DefaultModifier": {

        "OnAdded": [

            {

                "$type": "MoleMole.ModifyProperty",

                "PropertyType": "Custom",

                "CustomPropertyType": "MaxEnhanceNum",

                "PropertyModifyFunction": "Replace",

                "Percentage": 0,

                "Amount": "%AS_MaxEnhanceNum_Default"

            }

        ]

    },

    "OnAbilityStart": [

        {

            "$type": "MoleMole.ModifyProperty",

            "PropertyType": "Custom",

            "CustomPropertyType": "EnhanceNum",

            "PropertyModifyFunction": "Add",

            "Percentage": 0,

            "Amount": "%AS_EnhanceNum_Default"

        },

        {

            "$type": "MoleMole.ApplyModifier",

            "ModifierName": "EnhanceModifier",

            "Predicates": [

                {

                    "$type": "MoleMole.ByAnimCtrlerParam",

                    "ParamType": 2,

                    "ParamName": "Bool_Talent_04",

                    "CompareType": "Equal",

                    "BoolVal": false

                }

            ]

        },

        //十一号天赋04：火焰附魔状态下，将不再有次数限制，且增益时长提升至15秒

        {

            "$type": "MoleMole.ApplyModifier",

            "ModifierName": "Talent04EnhanceModifier",

            "Predicates": [

                {

                    "$type": "MoleMole.ByAnimCtrlerParam",

                    "ParamType": 2,

                    "ParamName": "Bool_Talent_04",

                    "CompareType": "Equal",

                    "BoolVal": true

                }

            ]

        }

    ],

    "AbilityMixins": [

        {

            "$type": "MoleMole.ActionsOnPropertyChangeMixin",

            "PropertyActions": [

                {

                    "PropertyType": "Custom",

                    "CustomPropertyType": "EnhanceNum",

                    // "ReferMaxPropertyType": "Custom",

                    // "CustomReferMaxPropertyType": "MaxEnhanceNum",

                    "IsUsePercentage": false,

                    "ValueRangeActions": [

                        {

                            "Val": 0,

                            "HighToValueActions": [

                                {

                                    "$type": "MoleMole.RemoveModifier",

                                    "ModifierName": "EnhanceModifier",

                                    //若天赋4解锁次数扣尽后效果也不移除

                                    "Predicates": [

                                        {

                                            "$type": "MoleMole.ByAnimCtrlerParam",

                                            "ParamType": 2,

                                            "ParamName": "Bool_Talent_04",

                                            "CompareType": "Equal",

                                            "BoolVal": false

                                        }

                                    ]

                                }

                            ]

                        }

                    ]

                }

            ]

        }

    ],

    "Modifiers": {

        //初始火附魔强化状态

        "EnhanceModifier": {

            "ModifierStacking": "Refresh",

            "Duration": "%AS_Duration_Default",

            "IgnoreTimeScale": false,

            "OnAdded": [

                {

                    "$type": "MoleMole.SetAnimCtrlerParamAction",

                    "ParamType": 2,

                    "ParamName": "Bool_IsEnhanced",

                    "Target": "Self",

                    "BoolVal": true

                },

                {

                    "$type": "MoleMole.AttachEffect",

                    "EffectPattern": "Eff_Anbi_Fire_Flame_Loop",

                    "Target": "Self",

                    "AttachEffectPosRot": {

                        "CoordsOption": "ReferTarget",

                        "TargetOption": {

                            "$type": "MoleMole.ConfigPosRotReferTarget",

                            "OffsetReferTarget": "Self",

                            "AttachPoint": "Weapon02",

                            "IsUseAttachPointPos": true,

                            "IsUseAttachPointRotation": true,

                        },

                        "Offset": {

                            "PositionOffset": {

                                "x": 0.0,

                                "y": 0.0,

                                "z": 0.0

                            },

                            "AngleOffset": {

                                "x": 0.0,

                                "y": 0.0,

                                "z": 0.0

                            },

                            "IsUseRotationY": true,

                            "IsUseRotationXZ": true,

                        }

                    },

                },

                //源： Longinus_Talent_01 十一号天赋01：火焰附魔状态下，自身暴击伤害提升15%

                {

                    "$type": "MoleMole.ApplyModifier",

                    "ModifierName": "LonginusTalent01Modifier",

                    "Target": "Self",

                    "Predicates": [

                        {

                            "$type": "MoleMole.ByAnimCtrlerParam",

                            "ParamType": 2,

                            "ParamName": "Bool_Talent_01",

                            "CompareType": "Equal",

                            "BoolVal": true

                        }

                    ]

                }

            ],

            "OnRemoved": [

                {

                    "$type": "MoleMole.SetAnimCtrlerParamAction",

                    "ParamType": 2,

                    "ParamName": "Bool_IsEnhanced",

                    "Target": "Self",

                    "BoolVal": false

                },

                {

                    "$type": "MoleMole.ModifyProperty",

                    "PropertyType": "Custom",

                    "CustomPropertyType": "EnhanceNum",

                    "PropertyModifyFunction": "Add",

                    "Percentage": 0,

                    "Amount": -99,

                },

                //天赋1效果移除

                {

                    "$type": "MoleMole.RemoveModifier",

                    "ModifierName": "LonginusTalent01Modifier",

                    "Target": "Self"

                }

            ]

        },

        //十一号天赋04：火焰附魔状态下，将不再有次数限制，且增益时长提升至15秒

        "Talent04EnhanceModifier": {

            "ModifierStacking": "Refresh",

            "Duration": "%AS_Duration_Talent04",

            "IgnoreTimeScale": false,

            "OnAdded": [

                {

                    "$type": "MoleMole.SetAnimCtrlerParamAction",

                    "ParamType": 2,

                    "ParamName": "Bool_IsEnhanced",

                    "Target": "Self",

                    "BoolVal": true

                },

                {

                    "$type": "MoleMole.AttachEffect",

                    "EffectPattern": "Eff_Anbi_Fire_Flame_Loop",

                    "Target": "Self",

                    "AttachEffectPosRot": {

                        "CoordsOption": "ReferTarget",

                        "TargetOption": {

                            "$type": "MoleMole.ConfigPosRotReferTarget",

                            "OffsetReferTarget": "Self",

                            "AttachPoint": "Weapon02",

                            "IsUseAttachPointPos": true,

                            "IsUseAttachPointRotation": true,

                        },

                        "Offset": {

                            "PositionOffset": {

                                "x": 0.0,

                                "y": 0.0,

                                "z": 0.0

                            },

                            "AngleOffset": {

                                "x": 0.0,

                                "y": 0.0,

                                "z": 0.0

                            },

                            "IsUseRotationY": true,

                            "IsUseRotationXZ": true,

                        }

                    },

                },

                //源： Longinus_Talent_01 十一号天赋01：火焰附魔状态下，自身暴击伤害提升15%

                {

                    "$type": "MoleMole.ApplyModifier",

                    "ModifierName": "LonginusTalent01Modifier",

                    "Target": "Self",

                    "Predicates": [

                        {

                            "$type": "MoleMole.ByAnimCtrlerParam",

                            "ParamType": 2,

                            "ParamName": "Bool_Talent_01",

                            "CompareType": "Equal",

                            "BoolVal": true

                        }

                    ]

                }

            ],

            "OnRemoved": [

                {

                    "$type": "MoleMole.SetAnimCtrlerParamAction",

                    "ParamType": 2,

                    "ParamName": "Bool_IsEnhanced",

                    "Target": "Self",

                    "BoolVal": false

                },

                {

                    "$type": "MoleMole.ModifyProperty",

                    "PropertyType": "Custom",

                    "CustomPropertyType": "EnhanceNum",

                    "PropertyModifyFunction": "Add",

                    "Percentage": 0,

                    "Amount": -99,

                },

                //天赋1效果移除

                {

                    "$type": "MoleMole.RemoveModifier",

                    "ModifierName": "LonginusTalent01Modifier",

                    "Target": "Self"

                }

            ]

        },

        //天赋1爆伤增加15%

        "LonginusTalent01Modifier": {

            "ModifierStacking": "Unique",

            "Duration": -1,

            "IgnoreTimeScale": false,

            //爆伤增加30%

            "Properties": {

                "Actor_CriticalDamageRatioDelta": "%AS_CriticalDamage_Talent_01"

            }

        }

    },

    "AbilitySpecials": {

        //表格参数

        "AS_MaxEnhanceNum_Default": {

            "Value": 8

        },

        "AS_EnhanceNum_Default": {

            "Value": 8

        },

        "AS_Duration_Default": {

            "Value": 10

        },

        "AS_Duration_Talent04": {

            "Value": 15

        },

        "AS_CriticalDamage_Talent_01": {

            "Value": 0.15

        }

    }

}